private["_c","_count","_ctSlots","_dfPics","_display","_entry","_expr","_i","_idc","_idx","_last","_prevDigit","_show","_unitClass","_unitSlots1","_unitSlots16","_unitSlots2","_unitSlots256","_unitSlots4","_unitSlots4096","_weaponSlots","_wlist"];
_display = _this select 0;
MORS_DGA_UNIT = _this select 1;
if( isNull _display) exitWith{ hint "display is null"; };

// SHOW ONLY WEAPON & MAGAZINE SLOTS AVAILABLE FOR THIS UNIT
// get the weapon slots definition for the unit class
_unitClass = typeOf MORS_DGA_UNIT;
_weaponSlots = toArray(getText(configFile >> "CfgVehicles" >> _unitClass >> "weaponSlots"));
// remove blank characters
_weaponSlots = _weaponSlots - [9];
_weaponSlots = _weaponSlots - [32];
// concat decimals into numbers
_prevDigit = false; _i=0;
while{_i < count _weaponSlots} do {
  _c = toString([_weaponSlots select _i]);
  if( _c=="*" || _c=="+" ) then {
    _weaponSlots Set[_i,_c];
    _prevDigit = false;
  } else {
    if( _prevDigit ) then {
      _weaponSlots Set[_i-1, format["%1%2", _weaponSlots select _i-1, _c]];
      _weaponSlots Set[_i,""];
      _weaponSlots = _weaponSlots - [""];
      _i = _i - 1;
    } else {
      _weaponSlots Set[_i,_c];
    };
    _prevDigit = true;
  };
  _i = _i + 1;
};
// translate the unit slots array into script variables we can use.
_unitSlots1 = 0; _unitSlots2 = 0; _unitSlots4 = 0; _unitSlots16 = 0; _unitSlots256 = 0; _unitSlots4096 = 0; _last = 0; _count = 1; _expr = "_unitSlots%1 = %2";
{
  switch( _x ) do {
    case '+': { // last number is a slot type
      call compile format[_expr,_last,_count];
      _expr = "_unitSlots%1 = %2";
      _count = 1;
    };
    case '*': { // use last number to set the number of available slot of the following type (the next number)
      _count = _last;
    };
    default { // found a number, decide its purpose
      if( _count > 1 ) then { call compile format[_expr, parseNumber _x, _last]; } else { _last = parseNumber _x; };
    };
  };
} forEach _weaponSlots;

// SET THE LIST OF AVAILABLE SLOTS AND SHOW/HIDE THEM ACCORDINGLY
// primary weapon slot
  _show = (_unitSlots1 == 1);
  _idx = lbAdd [idcMorsDgaSlots, "1"];
  lbSetValue[idcMorsDgaSlots, _idx, {true}count[_show]];
  lbSetData [idcMorsDgaSlots, _idx, format["%1", [idcMorsDgaWpn1,"\ca\ui\data\ui_gear_gun_gs.paa"]]];
  ctrlShow[idcMorsDgaWpn1, _show];
// secondary weapon slot
  _show = (_unitSlots2 == 1);
  _idx = lbAdd [idcMorsDgaSlots, "4"];
  lbSetValue[idcMorsDgaSlots, _idx, {true}count[_show]];
  lbSetData [idcMorsDgaSlots, _idx, format["%1", [idcMorsDgaWpn2,"\ca\ui\data\ui_gear_sec_gs.paa"]]];
  ctrlShow[idcMorsDgaWpn2, _show];
// weapon magazines slots
  _ctSlots = [idcMorsDgaMag1,idcMorsDgaMag2,idcMorsDgaMag3,idcMorsDgaMag4,idcMorsDgaMag5,idcMorsDgaMag6,idcMorsDgaMag7,idcMorsDgaMag8,idcMorsDgaMag9,idcMorsDgaMag10,idcMorsDgaMag11,idcMorsDgaMag12];
  _dfPics = ["\ca\ui\data\ui_gear_mag_gs.paa","\ca\ui\data\ui_gear_mag_gs.paa","\ca\ui\data\ui_gear_mag_gs.paa","\ca\ui\data\ui_gear_mag_gs.paa","\ca\ui\data\ui_gear_mag_gs.paa","\ca\ui\data\ui_gear_mag_gs.paa","\ca\ui\data\ui_gear_mag2_gs.paa","\ca\ui\data\ui_gear_mag2_gs.paa","\ca\ui\data\ui_gear_mag2_gs.paa","\ca\ui\data\ui_gear_mag2_gs.paa","\ca\ui\data\ui_gear_mag2_gs.paa","\ca\ui\data\ui_gear_mag2_gs.paa"];
  for "_i" from 0 to (count _ctSlots)-1 do {
    _show = (_i < _unitSlots256);
    _idc = _ctSlots select _i;
    _idx = lbAdd [idcMorsDgaSlots, "256"];
    lbSetValue[idcMorsDgaSlots, _idx, {true}count[_show]];
    lbSetData [idcMorsDgaSlots, _idx, format["%1", [_idc, _dfPics select _i]]];
    ctrlShow[_idc,_show];
  };
// handgun slot
  _show = (_unitSlots4 == 1);
  _idx = lbAdd [idcMorsDgaSlots, "2"];
  lbSetValue[idcMorsDgaSlots, _idx, {true}count[_show]];
  lbSetData [idcMorsDgaSlots, _idx, format["%1", [idcMorsDgaHGun, "\ca\ui\data\ui_gear_hgun_gs.paa"]]];
  ctrlShow[idcMorsDgaHGun, _show];
// handgun magazines slots
  _ctSlots = [idcMorsDgaHGMag1,idcMorsDgaHGMag2,idcMorsDgaHGMag3,idcMorsDgaHGMag4,idcMorsDgaHGMag5,idcMorsDgaHGMag6,idcMorsDgaHGMag7,idcMorsDgaHGMag8];
  for "_i" from 0 to (count _ctSlots)-1 do {
    _show = (_i < _unitSlots16);
    _idc = _ctSlots select _i;
    _idx = lbAdd [idcMorsDgaSlots, "16"];
    lbSetValue[idcMorsDgaSlots, _idx, {true}count[_show]];
    lbSetData [idcMorsDgaSlots, _idx, format["%1", [_idc,"\ca\ui\data\ui_gear_hgunmag_gs.paa"]]];
    ctrlShow[_idc,_show];
  };
// special items/gear slots
  _ctSlots = [idcMorsDgaGear1,idcMorsDgaGear2];
  for "_i" from 0 to (count _ctSlots)-1 do {
    _show = (_i < _unitSlots4096);
    _idc = _ctSlots select _i;
    _idx = lbAdd [idcMorsDgaSlots, "4096"];
    lbSetValue[idcMorsDgaSlots, _idx, {true}count[_show]];
    lbSetData [idcMorsDgaSlots, _idx, format["%1", [_idc,"\ca\ui\data\ui_gear_eq_gs.paa"]]];
    ctrlShow[_idc,_show];
  };


// FILL WEAPONS LISTBOX
ctrlShow [idcMorsDgaWList,false]; lbClear idcMorsDgaWList;
_wlist = MORS_DGA_ALLWPNS + MORS_DGA_ALLGEAR;
_i = count _wlist -1;
while {_i > -1} do {
  _entry = _wlist select _i;
  _idx = lbAdd [idcMorsDgaWList, _entry select 1];
  lbSetData [idcMorsDgaWList, _idx, _entry select 0];
  lbSetValue[idcMorsDgaWList, _idx, _idx];
  lbSetPicture [idcMorsDgaWList, _idx, _entry select 2];
  _i = _i - 1;
};
lbSort (_display displayCtrl idcMorsDgaWList); ctrlShow [idcMorsDgaWList,true];

// FILL MAGAZINES LISTBOX
ctrlShow [idcMorsDgaMList,false]; lbClear idcMorsDgaMList;
_i = count MORS_DGA_ALLMAGS -1;
while {_i > -1} do {
  _entry = MORS_DGA_ALLMAGS select _i;
  _idx = lbAdd [idcMorsDgaMList, _entry select 1];
  lbSetData [idcMorsDgaMList, _idx, _entry select 0];
  lbSetValue[idcMorsDgaMList, _idx, _idx];
  lbSetPicture [idcMorsDgaMList, _idx, _entry select 2];
  _i = _i - 1;
};
lbSort (_display displayCtrl idcMorsDgaMList); ctrlShow [idcMorsDgaMList,true];

// show current weapons and magazines
{["SELECT",_x] call morsDgaSelectWeapon;} forEach weapons MORS_DGA_UNIT;
{["SELECT",_x] call morsDgaSelectMagazine;} forEach magazines MORS_DGA_UNIT;
