private["_action","_type","_i","_slot","_idx","_data","_class","_replace","_mg","_entry","_name","_pic","_lawSlot","_lawIdx","_lawData","_mgSlot","_mgIdx","_mgData","_mgType","_x"];
_action = _this select 0;

if( _action == "REMOVE" ) exitWith {
  _type = _this select 1;
  _i = 0;
  if( count _this > 2 ) then { _i = _this select 2; };
  _slot = [_type, true] call morsDgaSlotInfo;
  if( count _slot == 0 ) exitWith {};
  _idx = (_slot select _i) select 0;
  _data = (_slot select _i) select 1;
  lbSetData[idcMorsDgaSlots, _idx, format["%1",[_data select 0,_data select 1]]];
  ctrlSetText[_data select 0, _data select 1];
};

_class = _this select 1;
_replace = false;
_mg = false;
_entry = (configFile >> "CfgWeapons" >> _class);
_name = getText (_entry >> "displayName");
_pic = getText(_entry >> "picture");
_type = getNumber(_entry >> "type");
if( _type == 5 ) then { _type = 1; _mg = true; }; // handle also machineguns (which are normally type 5)

if( _action == "REPLACE" ) then {
  _replace = true;
};

switch( _type ) do {
  case 1:{ // primary weapon
    _slot = [_type, _replace] call morsDgaSlotInfo;
    if( count _slot == 0 ) exitWith {};
    _idx = (_slot select 0) select 0;
    _data = (_slot select 0) select 1;
    // first make sure we dont have some secondary weapon - otherwise we couldn't add a multislot machinegun.
    if( _mg ) then {
      _lawSlot = [4,true] call morsDgaSlotInfo;
      _lawIdx = (_lawSlot select 0) select 0;
      _lawData = (_lawSlot select 0) select 1;
      if( count _lawData > 2 ) then {
        lbSetData[idcMorsDgaSlots, _lawIdx, format["%1",[_lawData select 0,_lawData select 1]]];
        ctrlSetText[_lawData select 0,_lawData select 1];
      };
    };
    _data Set [2,_class];
    lbSetData[idcMorsDgaSlots, _idx, format["%1",_data]];
    ctrlSetText[_data select 0, _pic];
  };
  case 2:{ // handgun
    _slot = [_type, _replace] call morsDgaSlotInfo;
    if( count _slot == 0 ) exitWith {};
    _idx = (_slot select 0) select 0;
    _data = (_slot select 0) select 1;
    _data Set [2,_class];
    lbSetData[idcMorsDgaSlots, _idx, format["%1",_data]];
    ctrlSetText[_data select 0, _pic];
  };
  case 4:{ // secondary weapon
    _slot = [_type, _replace] call morsDgaSlotInfo;
    if( count _slot == 0 ) exitWith {};
    _idx = (_slot select 0) select 0;
    _data = (_slot select 0) select 1;
    // first make sure we dont have some machinegun - then we cant have secondary weapon.
    _mgSlot = [1,true] call morsDgaSlotInfo;
    _mgIdx = (_mgSlot select 0) select 0;
    _mgData = (_mgSlot select 0) select 1;
    if( count _mgData > 2 ) then {
      // get info about the weapon class used in primary slot
      _mgType = getNumber(configFile >> "CfgWeapons" >> (_mgData select 2) >> "type" );
      if( _mgType == 5 ) then {
        lbSetData[idcMorsDgaSlots, _mgIdx, format["%1",[_mgData select 0,_mgData select 1]]];
        ctrlSetText[_mgData select 0, "\ca\ui\data\ui_gear_gun_gs.paa"];
      };
    };
    _data Set [2,_class];
    lbSetData[idcMorsDgaSlots, _idx, format["%1",_data]];
    ctrlSetText[_data select 0, _pic];
  };
  case 5:{}; // multiple slot guns (machineguns) are handled also by type 1.
  case 4096:{ // gear items
    _slot = [_type, true] call morsDgaSlotInfo;
    _i = {(_x select 1) select 2 == _class} count _slot;
    if( _i > 0 ) exitWith {};

    _slot = [_type] call morsDgaSlotInfo;
    if( count _slot == 0 ) exitWith {};
    _idx = (_slot select 0) select 0;
    _data = (_slot select 0) select 1;
    _data Set [2,_class];
    lbSetData[idcMorsDgaSlots, _idx, format["%1",_data]];
    ctrlSetText[_data select 0, _pic];
  };
};
