private["_magsProcessed","_i","_entry","_scope","_name","_class","_pic","_type","_mags","_muzzles","_magsProcessed"];

morsDGAOnKeyUp = compile preprocessFile "mors_dga\dga_onkeyup.sqf";
morsDGAShowDialog = compile preprocessFile "mors_dga\dga_show_dialog.sqf";
morsDGAResetDialog = compile preprocessFile "mors_dga\dga_reset_dialog.sqf";
morsDgaSlotInfo = compile preprocessFile "mors_dga\dga_slot_info.sqf";
morsDgaSelectWeapon = compile preprocessFile "mors_dga\dga_select_weapon.sqf";
morsDgaSelectMagazine = compile preprocessFile "mors_dga\dga_select_magazine.sqf";
morsDgaGearup = compile preprocessFile "mors_dga\dga_gearup.sqf";

waitUntil{!IsNull (findDisplay 46)};
MORS_DGA_MAIN = findDisplay 46;
MORS_DGA_MAIN displaySetEventHandler ["KeyUp", "_this call morsDGAOnKeyUp"];
MORS_DGA_UNIT = ObjNull;

MORS_DGA_ALLWPNS = []; // array of all weapons (primary, secondary, multislot launchers/machineguns, handguns, everything)
MORS_DGA_ALLGEAR = []; // array of all gear items (binoculars, nightvision, etc.)
MORS_DGA_ALLMAGS = []; // array of all magazines for all weapons
_magsProcessed = []; // because of duplicities of classes in the Weapon >> magazines[] array, we need to track the magazines already processed.
_i = count(configFile >> "CfgWeapons") - 1;

while {_i >= 0} do {
  if( isClass((configFile >> "CfgWeapons") select _i) ) then {
    _entry = (configFile >> "CfgWeapons") select _i;
    _scope = getNumber (_entry >> "scope");
    _name = getText (_entry >> "displayName");
    _class = configName _entry;

    // get weapon
    if( _scope==2 && _name != "" ) then {
      _pic = getText(_entry >> "picture");
      _type = getNumber(_entry >> "type");
      if( _type in [1,2,4,5,4096] ) then {
        if( _type == 4096 ) then {
          MORS_DGA_ALLGEAR = MORS_DGA_ALLGEAR + [[_class,_name,_pic,_type]]; // collect gear/item
        } else {
          MORS_DGA_ALLWPNS = MORS_DGA_ALLWPNS + [[_class,_name,_pic,_type]]; // collect weapon
        };
      };
    };

    // get weapon magazines
    _mags = getArray(_entry >> "magazines");
    _muzzles = [] + getArray(_entry >> "muzzles");
    {_mags = _mags + getArray(_entry >> _x >> "magazines")} forEach _muzzles;
    {
      _entry = configFile >> "CfgMagazines" >> _x;
      _name = getText (_entry >> "displayName");
      if( !(_x in _magsProcessed) && _name != '' ) then {
        _type = getNumber (_entry >> "type");
        _scope = getNumber (_entry >> "scope");
        if( _type!=0 && _scope==2 ) then {
          _pic = getText (_entry >> "picture");
          MORS_DGA_ALLMAGS = MORS_DGA_ALLMAGS + [[_x,_name,_pic,_type]];
        };
        _magsProcessed = _magsProcessed + [_x];
      };
    } forEach _mags;

  };
  _i = _i - 1;
};
