#include "defines.hpp"
#include "mors_background.hpp"
#include "mors_picture.hpp"
#include "mors_text.hpp"
#include "mors_title.hpp"
#include "mors_list_box.hpp"
#include "mors_active_text.hpp"
#include "mors_button.hpp"
class rscMorsDGADialog {
  idd=IDD_MORS_DGA_DIALOG;
  access=0; enableSimulation=1; movingEnable=1; enableDisplay=1;
  class ControlsBackground {
    class bg_display : rscMorsPicture { moving=1; x=0.09; y=0.09625; w=0.7575; h=0.8075; text="\ca\ui\data\ui_gradient_start_gs.paa"; colorbackground[]={0.6, 0.6, 0.6, 0.4}; };
    class display_title : rscMorsTitle { x=0.335; y=0.08425; w=0.5; text=$STR_MORS_DGA_TITLE; };
    class bg_weapons_list : rscMorsBackground { x=0.0975; y=0.18625; w=0.4425; h=0.35; };
    class bg_magazines_list : bg_weapons_list { y=0.54625; };
    class bg_selected_gear : bg_weapons_list { x=0.5475; w=0.2925; h=0.57; colorText[]={1, 1, 1, 0.8}; };
  };
  class controls {
    class weapons_list_title : rscMorsText { x=0.091; y=0.15625; w=0.4425; h=0.03; text=$STR_MORS_DGA_AVAILABLE; };
    class available_slots : rscMorsListBox { idc=IDC_MORS_DGA_SLOTS; x=0; y=0; w=0; h=0;
      //onMouseButtonDblClick="hintC ((_this select 0) lbData (lbCurSel (_this select 0)))";
    };
    class weapons_list : rscMorsListBox { idc=IDC_MORS_DGA_WLIST; x=0.0975; y=0.19125; w=0.4425; h=0.34; canDrag=1;
      onMouseButtonDblClick="[""REPLACE"",(_this select 0) lbData (lbCurSel (_this select 0))] call morsDgaSelectWeapon";
    };
    class selected_gear_title : weapons_list_title { x=0.54; w=0.4425; h=0.03; text=$STR_MORS_DGA_CURRENT; };
    class magazines_list : weapons_list { idc=IDC_MORS_DGA_MLIST; x=0.0975; y=0.54625;
      onMouseButtonDblClick="[""SELECT"",(_this select 0) lbData (lbCurSel (_this select 0))] call morsDgaSelectMagazine";
    };

    class slot_primary : rscMorsActiveText { idc=IDC_MORS_DGA_WPN1; x=0.5625; y=0.20625; w=0.2625; h=0.12; text="\ca\ui\data\ui_gear_gun_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",1] call morsDgaSelectWeapon";
    };
    class slot_secondary : slot_primary { idc=IDC_MORS_DGA_WPN2; y=0.31625; text="\ca\ui\data\ui_gear_sec_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",4] call morsDgaSelectWeapon";
    };
    class slot_item1 : slot_primary { idc=IDC_MORS_DGA_MAG1; w=0.0375; h=0.05; y=0.44625; text="\ca\ui\data\ui_gear_mag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",256,0] call morsDgaSelectMagazine";
    };
    class slot_item2 : slot_item1 { idc=IDC_MORS_DGA_MAG2; x=0.6075; text="\ca\ui\data\ui_gear_mag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",256,1] call morsDgaSelectMagazine";
    };
    class slot_item3 : slot_item1 { idc=IDC_MORS_DGA_MAG3; x=0.6525; text="\ca\ui\data\ui_gear_mag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",256,2] call morsDgaSelectMagazine";
    };
    class slot_item4 : slot_item1 { idc=IDC_MORS_DGA_MAG4; x=0.6975; text="\ca\ui\data\ui_gear_mag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",256,3] call morsDgaSelectMagazine";
    };
    class slot_item5 : slot_item1 { idc=IDC_MORS_DGA_MAG5; x=0.7425; text="\ca\ui\data\ui_gear_mag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",256,4] call morsDgaSelectMagazine";
    };
    class slot_item6 : slot_item1 { idc=IDC_MORS_DGA_MAG6; x=0.7875; text="\ca\ui\data\ui_gear_mag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",256,5] call morsDgaSelectMagazine";
    };
    class slot_item7 : slot_item1 { idc=IDC_MORS_DGA_MAG7; y=0.50625; text="\ca\ui\data\ui_gear_mag2_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",256,6] call morsDgaSelectMagazine";
    };
    class slot_item8 : slot_item7 { idc=IDC_MORS_DGA_MAG8; x=0.6075; text="\ca\ui\data\ui_gear_mag2_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",256,7] call morsDgaSelectMagazine";
    };
    class slot_item9 : slot_item7 { idc=IDC_MORS_DGA_MAG9; x=0.6525; text="\ca\ui\data\ui_gear_mag2_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",256,8] call morsDgaSelectMagazine";
    };
    class slot_item10 : slot_item7 { idc=IDC_MORS_DGA_MAG10; x=0.6975; text="\ca\ui\data\ui_gear_mag2_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",256,9] call morsDgaSelectMagazine";
    };
    class slot_item11 : slot_item7 { idc=IDC_MORS_DGA_MAG11; x=0.7425; text="\ca\ui\data\ui_gear_mag2_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",256,10] call morsDgaSelectMagazine";
    };
    class slot_item12 : slot_item7 { idc=IDC_MORS_DGA_MAG12; x=0.7875; text="\ca\ui\data\ui_gear_mag2_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",256,11] call morsDgaSelectMagazine";
    };
    class slot_handgun : slot_primary { idc=IDC_MORS_DGA_HGUN; y=0.56625; w=0.0825; h=0.11; text="\ca\ui\data\ui_gear_hgun_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",2] call morsDgaSelectWeapon";
    };
    class slot_handgun_item1 : slot_item1 { idc=IDC_MORS_DGA_HGMAG1; x=0.6525; y=0.56625; text="\ca\ui\data\ui_gear_hgunmag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",16,0] call morsDgaSelectMagazine";
    };
    class slot_handgun_item2 : slot_handgun_item1 { idc=IDC_MORS_DGA_HGMAG2; x=0.6975; text="\ca\ui\data\ui_gear_hgunmag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",16,1] call morsDgaSelectMagazine";
    };
    class slot_handgun_item3 : slot_handgun_item1 { idc=IDC_MORS_DGA_HGMAG3; x=0.7425; text="\ca\ui\data\ui_gear_hgunmag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",16,2] call morsDgaSelectMagazine";
    };
    class slot_handgun_item4 : slot_handgun_item1 { idc=IDC_MORS_DGA_HGMAG4; x=0.7875; text="\ca\ui\data\ui_gear_hgunmag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",16,3] call morsDgaSelectMagazine";
    };
    class slot_handgun_item5 : slot_handgun_item1 { idc=IDC_MORS_DGA_HGMAG5; y=0.62625; text="\ca\ui\data\ui_gear_hgunmag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",16,4] call morsDgaSelectMagazine";
    };
    class slot_handgun_item6 : slot_handgun_item5 { idc=IDC_MORS_DGA_HGMAG6; x=0.6975; text="\ca\ui\data\ui_gear_hgunmag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",16,5] call morsDgaSelectMagazine";
    };
    class slot_handgun_item7 : slot_handgun_item5 { idc=IDC_MORS_DGA_HGMAG7; x=0.7425; text="\ca\ui\data\ui_gear_hgunmag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",16,6] call morsDgaSelectMagazine";
    };
    class slot_handgun_item8 : slot_handgun_item5 { idc=IDC_MORS_DGA_HGMAG8; x=0.7875; text="\ca\ui\data\ui_gear_hgunmag_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",16,7] call morsDgaSelectMagazine";
    };
    class slot_handgun_special1 : slot_item1 { idc=IDC_MORS_DGA_GEAR1; x=0.6; y=0.68625; w=0.09; h=0.05; text="\ca\ui\data\ui_gear_eq_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",4096,0] call morsDgaSelectWeapon";
    };
    class slot_handgun_special2 : slot_handgun_special1 { idc=IDC_MORS_DGA_GEAR2; x=0.6975; text="\ca\ui\data\ui_gear_eq_gs.paa";
      onMouseButtonDblClick="[""REMOVE"",4096,1] call morsDgaSelectWeapon";
    };

    class bt_cancel : rscMorsButton { idc=2; x=0.69; y=0.80625; text=$STR_DISP_CLOSE; };
    class bt_gearup : bt_cancel { idc=132; y=0.85625; text=$STR_GEAR_TAKE; default=1;
      onMouseButtonClick="[] call morsDgaGearup";
    };
  };
};