private["_i","_type","_data"];
if(isNull(findDisplay iddMorsDgaDialog) || isNull MORS_DGA_UNIT) exitWith{ MORS_DGA_UNIT = ObjNull; };

{MORS_DGA_UNIT removeWeapon _x} forEach weapons MORS_DGA_UNIT;
{MORS_DGA_UNIT removeMagazine _x} forEach magazines MORS_DGA_UNIT;

// set unit magazines
for "_i" from 0 to lbSize idcMorsDgaSlots do {
  _type = parseNumber lbText[idcMorsDgaSlots, _i];
  if(_type in [16,256,512,1536]) then {
    _data = call compile lbData[idcMorsDgaSlots, _i];
    if( count _data > 2 ) then {
      MORS_DGA_UNIT addMagazine (_data select 2);
    };
  };
};

// set unit weapons
for "_i" from 0 to lbSize idcMorsDgaSlots do {
  _type = parseNumber lbText[idcMorsDgaSlots, _i];
  if(_type in [1,2,4,5,4096]) then {
    _data = call compile lbData[idcMorsDgaSlots, _i];
    if( count _data > 2 ) then {
      MORS_DGA_UNIT addWeapon (_data select 2);
    };
  };
};

if( primaryWeapon MORS_DGA_UNIT != "" ) then {
  MORS_DGA_UNIT selectWeapon (primaryWeapon MORS_DGA_UNIT);
} else {
  if( secondaryWeapon MORS_DGA_UNIT != "" ) then {
    MORS_DGA_UNIT selectWeapon (secondaryWeapon MORS_DGA_UNIT);
  };
};

closeDialog iddMorsDgaDialog;