private["_action","_type","_i","_slot","_idx","_data","_x","_class","_replace","_entry","_name","_pic","_occSlots"];
_action = _this select 0;

if( _action == "REMOVE" ) exitWith {
  _type = _this select 1;
  _i = 0;
  if( count _this > 2 ) then { _i = _this select 2; };
  _slot = [_type, true] call morsDgaSlotInfo;
  if( count _slot == 0 ) exitWith {};
  _idx = (_slot select _i) select 0;
  _data = (_slot select _i) select 1;
  if( count _data < 3 ) exitWith {};
  lbSetData[idcMorsDgaSlots, _idx, format["%1",[_data select 0,_data select 1]]];
  ctrlSetText[_data select 0, _data select 1];
  // clear and reset all additional slots also occupied by this magazine
  if( count _data > 3 ) then {
    {
      _data = call compile lbData[idcMorsDgaSlots, _x];
      lbSetData[idcMorsDgaSlots, _x, format["%1",[_data select 0,_data select 1]]];
      ctrlSetText[_data select 0, _data select 1];
    } forEach (_data select 4);
  };
};

_class = _this select 1;
_replace = false;
_entry = (configFile >> "CfgMagazines" >> _class);
_name = getText (_entry >> "displayName");
_pic = getText(_entry >> "picture");
_type = getNumber(_entry >> "type");

if( _action == "REPLACE" ) then {
  _replace = true;
};

switch( _type ) do {
  case 16:{ // handgun magazines
    _slot = [_type, _replace] call morsDgaSlotInfo;
    if( count _slot == 0 ) exitWith {};
    _idx = (_slot select 0) select 0;
    _data = (_slot select 0) select 1;
    _data Set [2,_class];
    _data Set [3,16];
    lbSetData[idcMorsDgaSlots, _idx, format["%1",_data]];
    ctrlSetText[_data select 0, _pic];
  };
  case 256:{ // primary and secondary weapon magazines
    _slot = [_type, _replace] call morsDgaSlotInfo;
    if( count _slot == 0 ) exitWith {};
    _idx = (_slot select 0) select 0;
    _data = (_slot select 0) select 1;
    _data Set [2,_class];
    _data Set [3,256];
    lbSetData[idcMorsDgaSlots, _idx, format["%1",_data]];
    ctrlSetText[_data select 0, _pic];
  };
  case 512:{ // double slot magazines
    _slot = [256, _replace] call morsDgaSlotInfo;
    if( count _slot < 2 ) exitWith {};
    _idx = (_slot select 0) select 0;
    _data = (_slot select 0) select 1;
    _data Set [2,_class];
    _data Set [3,512];
    // remember all additional slots also occupied with this magazine. 
    _data Set [4,[(_slot select 1) select 0]];
    lbSetData[idcMorsDgaSlots, _idx, format["%1",_data]];
    ctrlSetText[_data select 0, _pic];

    // disable also one following slot
    _idx = (_slot select 1) select 0;
    _data = (_slot select 1) select 1;
    _data Set [2,""];
    _data Set [3,512];
    lbSetData[idcMorsDgaSlots, _idx, format["%1",_data]];
    ctrlSetText[_data select 0, ""];
  };
  case 1536:{ // 6x slot magazines
    _slot = [256, _replace] call morsDgaSlotInfo;
    if( count _slot < 6 ) exitWith {};
    _idx = (_slot select 0) select 0;
    _data = (_slot select 0) select 1;
    _data Set [2,_class];
    _data Set [3,1536];
    // remember all additional slots also occupied with this magazine.
    _occSlots = [];
    for "_i" from 1 to 5 do {
      _occSlots = _occSlots + [(_slot select _i) select 0];
    };
    _data Set [4,_occSlots]; 
    lbSetData[idcMorsDgaSlots, _idx, format["%1",_data]];
    ctrlSetText[_data select 0, _pic];

    // disable also 5 following slots
    for "_i" from 1 to 5 do {
      _idx = (_slot select _i) select 0;
      _data = (_slot select _i) select 1;
      _data Set [2,""];
      _data Set [3,1536];
      lbSetData[idcMorsDgaSlots, _idx, format["%1",_data]];
      ctrlSetText[_data select 0, ""];
    };
  };
};
